VIGRA - VIGRA: BasicImageView Class Template Reference

[ VIGRA Homepage | Function Index | Class Index | Namespaces | File List | Main Page ]

| BasicImageView |

BasicImage using foreign memory. More...

`#include <vigra/basicimageview.hxx>`

List of all members.

## Public Types
typedef IteratorTraits < traverser >::DefaultAccessor | Accessor
typedef traverser::column_iterator | column_iterator
typedef const_traverser::column_iterator | const_column_iterator
typedef PIXELTYPE const * | const_iterator
typedef PIXELTYPE const * | const_pointer
typedef PIXELTYPE const & | const_reference
typedef const_traverser::row_iterator | const_row_iterator
typedef ConstImageIterator < value_type > | const_traverser
typedef IteratorTraits < const_traverser > ::DefaultAccessor | ConstAccessor
typedef ConstImageIterator < value_type > | ConstIterator
typedef PIXELTYPE const * | ConstScanOrderIterator
typedef Diff2D | difference_type
typedef ImageIterator< value_type > | Iterator
typedef PIXELTYPE * | iterator
typedef PIXELTYPE | PixelType
typedef PIXELTYPE * | pointer
typedef PIXELTYPE & | reference
typedef traverser::row_iterator | row_iterator
typedef PIXELTYPE * | ScanOrderIterator
typedef Size2D | size_type
typedef ImageIterator< value_type > | traverser
typedef PIXELTYPE | value_type
## Public Member Functions
ConstAccessor | accessor () const
Accessor | accessor ()
| BasicImageView (const_pointer data, difference_type const &size, int stride=0)
| BasicImageView (const_pointer data, int w, int h, int stride=0)
| BasicImageView ()
const_iterator | begin () const
iterator | begin ()
const_column_iterator | columnBegin (int x) const
column_iterator | columnBegin (int x)
const_column_iterator | columnEnd (int x) const
column_iterator | columnEnd (int x)
const_pointer | data () const
const_iterator | end () const
iterator | end ()
int | height () const
BasicImageView & | init (value_type const &pixel)
bool | isInside (difference_type const &d) const
const_traverser | lowerRight () const
traverser | lowerRight ()
const_reference | operator() (int dx, int dy) const
reference | operator() (int dx, int dy)
const_pointer | operator[] (int dy) const
pointer | operator[] (int dy)
const_reference | operator[] (difference_type const &d) const
reference | operator[] (difference_type const &d)
const_row_iterator | rowBegin (int y) const
row_iterator | rowBegin (int y)
const_row_iterator | rowEnd (int y) const
row_iterator | rowEnd (int y)
size_type | size () const
int | stride () const
const_traverser | upperLeft () const
traverser | upperLeft ()
int | width () const

## Detailed Description

### template<class PIXELTYPE>
class vigra::BasicImageView< PIXELTYPE >

BasicImage using foreign memory.

This class provides the same interface as vigra::BasicImage (with the exception of `resize()`) but the image's memory is provided from the outside instead of allocated internally.

A `BasicImageView` can also be created from a vigra::MultiArrayView with the appropriate shape -- see Wrap aref vigra::MultiArrayView in.

#include <vigra/basicimageview.hxx>

Namespace: vigra

## Member Typedef Documentation

typedef IteratorTraits<traverser>::DefaultAccessor Accessor

the BasicImageView's default accessor

typedef traverser::column_iterator column_iterator

the column iterator associated with the traverser

typedef const_traverser::column_iterator const_column_iterator

the const column iterator associated with the const_traverser

typedef PIXELTYPE const* const_iterator

the BasicImageView's 1D random access const iterator (note: lower case 'const_iterator' is a STL compatible 1D random access const iterator)

typedef PIXELTYPE const* const_pointer

the BasicImageView's const pointer type

typedef PIXELTYPE const& const_reference

the BasicImageView's const reference type (i.e. the return type of image[diff] and image(dx,dy) when image is const)

typedef const_traverser::row_iterator const_row_iterator

the const row iterator associated with the const_traverser

typedef ConstImageIterator<value_type> const_traverser

the BasicImageView's 2D random access const iterator ('const traverser')

typedef IteratorTraits<const_traverser>::DefaultAccessor ConstAccessor

the BasicImageView's default const accessor

typedef ConstImageIterator<value_type> ConstIterator

deprecated, use `const_traverser` instead

typedef PIXELTYPE const* ConstScanOrderIterator

deprecated, use `const_iterator` instead

typedef Diff2D difference_type

the BasicImageView's difference type (argument type of image[diff])

typedef ImageIterator<value_type> Iterator

deprecated, use `traverser` instead

typedef PIXELTYPE* iterator

the BasicImageView's 1D random access iterator (note: lower case 'iterator' is a STL compatible 1D random access iterator, don't confuse with capitalized Iterator)

typedef PIXELTYPE PixelType

the BasicImageView's pixel type

typedef PIXELTYPE* pointer

the BasicImageView's pointer type

typedef PIXELTYPE& reference

the BasicImageView's reference type (i.e. the return type of image[diff] and image(dx,dy))

typedef traverser::row_iterator row_iterator

the row iterator associated with the traverser

typedef PIXELTYPE* ScanOrderIterator

deprecated, use `iterator` instead

typedef Size2D size_type

the BasicImageView's size type (result type of image.size())

typedef ImageIterator<value_type> traverser

the BasicImageView's 2D random access iterator ('traverser')

typedef PIXELTYPE value_type

the BasicImageView's pixel type

## Constructor & Destructor Documentation

BasicImageView | ( |  | ) |

construct image of size 0x0

BasicImageView | ( | const_pointer | data,
|  | int | w,
|  | int | h,
|  | int | stride = `0` |
| ) |  |  |

construct view of size w x h

BasicImageView | ( | const_pointer | data,
|  | difference_type const & | size,
|  | int | stride = `0` |
| ) |  |  |

construct view of size size.x x size.y

## Member Function Documentation

ConstAccessor accessor | ( |  | ) | const

return default const accessor

Accessor accessor | ( |  | ) |

return default accessor

const_iterator begin | ( |  | ) | const

init 1D random access const iterator pointing to first pixel. Note: Only works if stride equals width.

iterator begin | ( |  | ) |

init 1D random access iterator pointing to first pixel. Note: Only works if stride equals width.

const_column_iterator columnBegin | ( | int | x | ) | const

init 1D random access const iterator pointing to first pixel of column x

column_iterator columnBegin | ( | int | x | ) |

init 1D random access iterator pointing to first pixel of column x

const_column_iterator columnEnd | ( | int | x | ) | const

init 1D random access const iterator pointing past the end of column x

column_iterator columnEnd | ( | int | x | ) |

init 1D random access iterator pointing past the end of column x

const_pointer data | ( |  | ) | const

get a pointer to the internal data

const_iterator end | ( |  | ) | const

init 1D random access const iterator pointing past the end. Note: Only works if stride equals width.

iterator end | ( |  | ) |

init 1D random access iterator pointing past the end. Note: Only works if stride equals width.

int height | ( |  | ) | const

height of Image

BasicImageView& init | ( | value_type const & | pixel | ) |

set Image with const value

bool isInside | ( | difference_type const & | d | ) | const

test whether a given coordinate is inside the image

const_traverser lowerRight | ( |  | ) | const

init 2D random access const iterator poining to pixel(width, height), i.e. one pixel right and below lower right corner of the image as is common in C/C++.

traverser lowerRight | ( |  | ) |

init 2D random access iterator poining to pixel(width, height), i.e. one pixel right and below lower right corner of the image as is common in C/C++.

const_reference operator() | ( | int | dx,
|  | int | dy |
| ) |  |  | const

read pixel at given location.
usage: `value_type value = image(1,2)`

reference operator() | ( | int | dx,
|  | int | dy |
| ) |  |  |

access pixel at given location.
usage: `value_type value = image(1,2)`

const_pointer operator[] | ( | int | dy | ) | const

read pixel at given location. Note that the 'x' index is the trailing index.
usage: `value_type value = image[2][1]`

pointer operator[] | ( | int | dy | ) |

access pixel at given location. Note that the 'x' index is the trailing index.
usage: `value_type value = image[2][1]`

const_reference operator[] | ( | difference_type const & | d | ) | const

read pixel at given location.
usage: `value_type value = image[Diff2D(1,2)]`

reference operator[] | ( | difference_type const & | d | ) |

access pixel at given location.
usage: `value_type value = image[Diff2D(1,2)]`

const_row_iterator rowBegin | ( | int | y | ) | const

init 1D random access const iterator pointing to first pixel of row y

row_iterator rowBegin | ( | int | y | ) |

init 1D random access iterator pointing to first pixel of row y

const_row_iterator rowEnd | ( | int | y | ) | const

init 1D random access const iterator pointing past the end of row y

row_iterator rowEnd | ( | int | y | ) |

init 1D random access iterator pointing past the end of row y

size_type size | ( |  | ) | const

size of Image

int stride | ( |  | ) | const

stride of Image. Memory offset between the start of two successive rows.

const_traverser upperLeft | ( |  | ) | const

init 2D random access const iterator poining to upper left pixel

traverser upperLeft | ( |  | ) |

init 2D random access iterator poining to upper left pixel

int width | ( |  | ) | const

width of Image

The documentation for this class was generated from the following file:

- vigra/basicimageview.hxx

© Ullrich Köthe (ullrich.koethe@iwr.uni-heidelberg.de) Heidelberg Collaboratory for Image Processing, University of Heidelberg, Germany | html generated using doxygen and Python VIGRA 1.6.0 (13 Aug 2008)